package in.ashokit;


import java.util.WeakHashMap;

public class WeakHashMapTest{
	
	public static void main(String args[]) throws Exception{
	
		WeakHashMap<Person,String> hm=new WeakHashMap<>();
		Person t=new Person();
		hm.put(t,"Ashok");
		
		
		System.out.println("Weak hash Map : " + hm);
		
		
		t=null;
		
		System.gc();
		
		Thread.sleep(500);
		System.out.println("Weak hash Map : " + hm);
		
	
	}
}

class Person{
	
	public String toString(){
		return "Temp";
	}
	
	public void finalize(){
		System.out.println("finalize method is called");
	}

}	
	

	/*
	
	Output:
	
	If we take WeakHashMap then output will be
	
	Weak hash Map : {Temp=Ashok}
	finalize method is called
	Weak hash Map : {}
	
	If we take   hash Map : {Temp=Ashok}
	Weak hash Map : {Temp=Ashok}
	HashMap then output will be
	


	*/
	
	
	
	
	
	
